from tools import sum_digits
from testing import assert_equal, run_tests


def test_empty_string():
    # Prepare situation (Given)
    expected = 0
    # Exercice the SUT (When)
    observed = sum_digits("")
    # Check results (Then)
    return assert_equal(observed, expected)


def test_only_chars():
    return assert_equal(sum_digits("abcde"), 0)


def test_1():
    return assert_equal(sum_digits("1"), 1)


def test_123():
    return assert_equal(sum_digits("123"), 6)


def test_12_point_3():
    return assert_equal(sum_digits("12.3"), 6)


def test_all_numbers():
    return assert_equal(sum_digits("0123456789"), 45)


def test_white_chars():
    return assert_equal(sum_digits(" \n\r\t"), 0)


run_tests()
# test_empty_string()
# test_only_chars()
# test_1()
