import sys


def assert_equal(observed, expected):
    caller_frame = sys._getframe(1)
    fname = caller_frame.f_code.co_filename
    linenum = caller_frame.f_lineno
    name = caller_frame.f_code.co_name
    if expected == observed:
        print(".", end="")
        return True
    else:
        print(f"\nTest {name} at {fname}:{linenum} failed:")
        print(f"-- Expected: {expected}")
        print(f"-- But got: {observed}")
        return False


def run_tests():
    results = []
    caller_frame = sys._getframe(1)
    for symbol, value in caller_frame.f_globals.items():
        if symbol.startswith("test_"):
            test_function = value
            result = test_function()
            results.append(result)
    print("\n=======")
    print(f"{len(results)} tests executed.")
    print(f"{sum(results)} tests passed.")
    print(f"{len(results)-sum(results)} tests failed.")
